// DEFTEXT      This class is copyright (c) by methodica herger & krasznai
// Address:     Fellstr. 3, P.O. Box 39, CH-5413 Switzerland
// Internet:    http://www.methodica.ch, mail@methodica.ch
//
// Purpose:     This is a text server class delivering line by line of text 
//              to the TICKER.CLASS applet. DEFTEXT is the default text server. 
//              It automatically is activated by TICKER when no other server, no
//              text file URL and no text literal has been specified by the user.
//
// Notes:       TICKER applet text server classes must extend the TXTSRVR class.
//              To implement a specific server, you may modify DEFTEXT.CLASS.
//              A more favorable way is, to implement a specific server, based
//              upon the TXTSRVR class and activate it via a PARAM entry in your
//              HTML code. The Y2KDTXT.CLASS is such a specific server.
//
//              This code is freeware. You are free to use and modify it, as 
//              long as due credit is given, and the resulting source code is 
//              made available to the public too.
//              If you use this code, drop us a line ("mail@Tmethodica.ch"), so
//              that we know, how many people are using it, and what an impact
//              modifications to it will have.
//
//              The code is given to the public domain on an "as is" basis.
//              This means, that neither the author, nor methodica can be made
//              responsible, under any circumstances, for damages caused by this
//              applet, or malfunctions of this applet. Since the source code
//              is in the public domain, you might convince yourself of the fact,
//              that it doesn't contain offending or destructive code.
//
//              1998-06-10, Hans E. Herger <hans.herger@methodica.ch>

import java.net.URL;

public class deftext extends txtsrvr
{
    protected String messages[] =    
    {
        "--> Note to the webmaster: no text specified for displaying! <--",
        "Insert a 'PARAM' entry into your HTML code as in the following " +
          "example: <param name=\"Text\" value=\"text to display...\">",
        "As an alternative, you could modify the deftext.class file " +
          "(deftext.java), which is the default text server for the " +
          "'ticker.class' applet.",
        "You may download the source code for free from our home  page: " +
          "http://www.methodica.ch|_blank|http://www.methodica.ch/download"
    };
    protected static int imax = 4;   // number of entries in the above array
    protected int icur;              // number of entry to display next

    // Standard constructor.
    //--------------------------------------------------------------------------
    public void txtsrvr()
    {
		initText(null, null, 0, 0);
    } // end of constructor deftext

    // Initializes the class. Returns "true" if successful.
    //--------------------------------------------------------------------------
	public boolean initText(URL uParam, String sParam, long lParam, int iParam)
	{
		icur = 0;
		return true;
	} // end of method initText

    // Exits the class. Returns "true" if successful.
    //--------------------------------------------------------------------------
	public void exitText()
	{
	} // end of method exitText

    // Returns the text to be displayed.
    //--------------------------------------------------------------------------
    public String getText()
    {
        // return the logically next text string from the internal buffer
        if (icur > imax) { icur = 1; }
        else
        {
            icur++;
        }
        return messages[icur-1];
    } // end of method getText

}
