// FILDTXT      This class is copyright (c) by methodica herger & krasznai
// Address:     Fellstr. 3, P.O. Box 39, CH-5413 Switzerland
// Internet:    http://www.methodica.ch, mail@methodica.ch
//
// Purpose:     This is a text server class delivering line by line of text
//              to the TICKER.CLASS applet. FILDTXT reads text from an ASCII
//              file who's name is specified via the following entry in your
//              HTML code:
//                  <PARAM NAME="TextFile" VALUE="text_file_URL".
//                  Examples for "text_file_URL" are:
//                      "TICKER.TXT"  (*)
//                      "http://www.methodica.ch/y2kstmts.txt"
//                      "file://C|///hello.asc"
//                      (*) file is addressed relative to the current
//                          document path, i.e. the directory the active HTML-
//                          page stems from.
//                Note: Applets in general only may read files from the
//                      web server they are loaded from. So can an applet
//                      loaded from the methodica web server (codebase=
//                      http://www.methodica.ch/ticker/) e.g. access the file
//                      http://www.methodica.ch/welcome.txt but not the file
//                      http://www.das-fanmagazin.de/ticker/info.txt
//
// Notes:       TICKER applet text server classes must extend the TXTSRVR class.
//
//              This code is freeware. You are free to use and modify it, as
//              long as due credit is given, and the resulting source code is
//              made available to the public too.
//              If you use this code, drop us a line ("mail@methodica.ch"), so
//              that we know, how many people are using it, and what an impact
//              modifications to it will have.
//
//              The code is given to the public domain on an "as is" basis.
//              This means, that neither the author, nor methodica can be made
//              responsible, under any circumstances, for damages caused by this
//              applet, or malfunctions of this applet. Since the source code
//              is in the public domain, you might convince yourself of the fact,
//              that it doesn't contain offending or destructive code.
//
//              2001-11-13, Hans E. Herger <hans.herger@methodica.ch>

import java.io.InputStream;
import java.io.DataInputStream;
// import java.io.InputStreamReader;
// import java.io.BufferedReader;
import java.io.IOException;
import java.net.URL;
import java.net.MalformedURLException;
import java.applet.Applet;

public class fildtxt extends txtsrvr
{
	protected InputStream       is      = null;
	protected DataInputStream   di      = null;
//	protected BufferedInputStream is      = null;
//	protected BufferedReader di      = null;


  static String EmptyString = "";
  static String DebugText = "";

    // Standard constructor.
    //--------------------------------------------------------------------------
    public void txtsrvr()
    {
    } // end of constructor txtsrvr

    private void closeStrm()
    {
		if (di != null)
		{
		    try   { di.close(); di = null; }
		    catch (IOException e) {};
		}
		if (is != null)
		{
		    try   { is.close(); is = null; }
		    catch (IOException e) {};
		}
    }

    // Initializes the class. Returns "true" if successful.
    //--------------------------------------------------------------------------
    public boolean initText(URL uParam, String sParam, long lParam, int iParam)
    {
       closeStrm();

    if (sParam == null) return true;

    try
        {
          if (uParam != null)
          {
            if (uParam.getProtocol() == "")
            {
               sParam = "http://" + uParam.getHost() + "/" + ":" +
               uParam.getPort() + "/" + uParam.getFile() + "#" +
               uParam.getRef();
            }
          }
          is = new URL(uParam, sParam).openStream();
	  di = new DataInputStream(is);
//	  di = new BufferedReader( new InputStreamReader(is));
       }
	    catch (MalformedURLException e)
      {
        DebugText = "***ERROR: bad URL (" +
                uParam.getProtocol() + "://" +
                uParam.getHost() + ":" +
                uParam.getPort() + "/" + uParam.getFile() + "#" +
                uParam.getRef() + ")";
        return true;
      }
	    catch (IOException e)
      {
        DebugText = "*** ERROR: IO-Error reading input stream";
        return true;
      }
		return true;

	} // end of method initText



    // Exits the class. Returns "true" if successful.
    //--------------------------------------------------------------------------
	public void exitText()
	{
	    closeStrm();
	}

    // Returns the text to be displayed.
    //--------------------------------------------------------------------------
    public String getText()
    {
        if (DebugText != "") {return DebugText; }
        if (di != null)
        {
            // we are to read text from a file
            try
            {
                return di.readLine();
            }
            catch (IOException ioe1)
            {
		        return "*** ERROR: IO-Error reading text file ***";
            }
		}
		return "*** ERROR: No input stream available. You probably didn't specify a TextFile source ***";
    } // end of method getText

} // end of class fildtxt
