// LOGGER   This class is copyright (c) by methodica herger & krasznai
//          Address:   Fellstr. 3, P.O. Box 80, CH-5413 Switzerland
//          Internet:  http://www.methodica.ch, mail@methodica.ch
//
//          This class is intended for logging the ticker.class applet
//          usage. It tries to append a log entry to a file residing
//          on the same host and in the same directory as the logger.class
//          is executed from.
//          Applets call logger as follows:
//                doLog(docBase, codBase, logText);
//          e.g.: doLog(getDocumentBase(), getCodeBase(), getAppletInfo());
//
//          By replacing this class file by one implementing the same
//          interface, but without active code, the logging feature can
//          be disabled. As an alternative, the following HTML code will
//          disallow the ticker.class applet for calling looger.class:
//              <PARAM NAME="Logging" VALUE="off">.
//
//          This code is freeware.
//          You are free to use and modify it, as long as due credit is
//          given, and the resulting source code is made available to the
//          public too.
//          If you use this code, drop us a line ("mail@Tmethodica.ch"), so
//          that we know, how many people are using it, and what an impact
//          modifications to it will have.
//
//          The code is given to the public domain on an "as is" basis.
//          This means, that neither the author, nor methodica can be made
//          responsible under any circumstances for damages caused by this
//          applet or malfunctions of this applet. Since the source codue
//          is published, you might convince yourself of the fact, that the
//          applet contains no offending or destructive code.
//
//          2001-02-20, Hans E. Herger <hans.herger@methodica.ch>

// import java.net.*;
import java.net.URL;
import java.net.MalformedURLException;
import java.net.URLEncoder;
import java.io.InputStream;
import java.io.DataInputStream;
import java.io.IOException;
import java.util.StringTokenizer;


public class logger // extends Object
{

   protected String           m_LogHost   = "";
   protected String           m_LogFName  = "";
   protected String           m_LogFExt   = "";
   protected String           m_LogFile   = "";
   protected int              m_LogPort   = 0;
   protected String           m_LogProto  = "";
   protected String           m_CfgURL    = "";
   protected String           m_LogURL    = "";
   protected Integer          m_MaxLog;
   protected boolean          m_LogActive;
   protected InputStream      is;
   protected DataInputStream  di;
   protected String           m_codBase;
   protected String           m_docBase;

   private   StringTokenizer  st;
   private   URL              xURL;
   private   static String    emptyString = "";
   private   static String    stcMaxLog   = "32768";

   // Standard constructor.
   //--------------------------------------------------------------------------
   public void logger()
   {
      m_codBase   = "";
      m_docBase   = "";
      m_LogActive = false;
      m_MaxLog = new Integer(stcMaxLog);
	   is          = null;
	   di          = null;
   } // constructor logger

   public void initLog(String codBase, String docBase)
   {
      String skey = "";
      String svalue = "";

      if (codBase == null) { return; }
      m_codBase = codBase;
      if (docBase != null) { m_docBase = docBase; }

      try
      {
         xURL = new URL(m_codBase);
         m_LogHost = xURL.getHost();
         m_LogFName= "logger";
         m_LogFExt = ".cfg";
         m_LogFile = xURL.getFile() + m_LogFName + m_LogFExt;
         m_LogPort = xURL.getPort();
         m_LogProto = xURL.getProtocol();
      }
      catch (MalformedURLException e0) { return; }

      m_CfgURL = m_LogProto + "://" + m_LogHost + m_LogFile;
      try { xURL = new URL(m_CfgURL); }
      catch (MalformedURLException e0) { return; }

      try
      {
         is = xURL.openStream();
         if (is==null) {  return;  }
         di = new DataInputStream(is);
         //	  di = new BufferedReader( new InputStreamReader(is));
      }
      catch (MalformedURLException e2) {  doClose(); return;  }
      catch (IOException e) {  doClose(); return;  }

      if (di == null) { return; }
      try {
         svalue = di.readLine();
         if (svalue.length() < 1) {  doClose(); return;  }

         do {
            st = new StringTokenizer(svalue, "=");
            if (st == null) {  doClose(); return;  }
            if (st.countTokens() < 2) {  doClose(); return;  }
            skey = st.nextToken();
            svalue = st.nextToken();

            if (skey.equalsIgnoreCase("LOGSCRIPT")) {
               m_LogURL = svalue;
            }
            else
            if (skey.equalsIgnoreCase("MAXLOGSIZE")) {
		         try {
			         m_MaxLog = Integer.valueOf(svalue);
               }
	         	catch (NumberFormatException e3) {
                  m_MaxLog = new Integer(stcMaxLog);
               }
            }

            svalue = di.readLine();
         } while ((svalue != null) && (svalue.length() > 0));
      }
      catch (IOException ioe1) {  doClose(); return;  }

      m_LogActive = (m_LogURL.length() > 0);

      doClose();
   } // method initLog(..)

   private void doClose()
   {
	   if (di != null)
		{
		   try   { di.close(); di = null; }
		   catch (IOException e) {};
		}
		if (is != null)
		{
		   try   { is.close(); is = null; }
		   catch (IOException e) {};
		}
    }  // method doClose

   // Inserts a log entry into the log file, reorganizing the log file
   // structure if necessary. Logging parameters are taken from the file
   // logger.cfg if available.
   //--------------------------------------------------------------------------
   public void doLog(String logText)
   {
      if (!m_LogActive) { return; }
      if (m_codBase.length() < 1) { return; }

      m_LogURL += "?TEXT=" + URLEncoder.encode(
         "Document: " + ((m_docBase.length() < 1) ? "-?-" : m_docBase) +
         "  Code: " + m_codBase + "  Text: " + logText );

      try {  xURL = new URL(m_LogURL);  }
      catch (MalformedURLException e) { return; }

      try {  is = new URL(xURL, emptyString).openStream();  }
      catch (IOException e2) { doClose(); return; }

      doClose();

   } // method doLog
} // class logger
